(* Extrahieren der Strings aus DRC-Dateien
   J. Rathlev, Okt. 2004
   letzte nderung, Dez. 2006
   *)

unit RdDrcStrings;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, HListBox, JrUtils, WinDesktop, ComCtrls,
  ExtCtrls, XPMan;

const
  Vers = ' Vers. 1.1';
  CopRgt = '(c) 2006 J. Rathlev, IEAP, Uni-Kiel';

  StrExt = 'txt';
  DrcExt = 'rc';

type
  THauptForm = class(TForm)
    Label2: TLabel;
    InfoBtn: TSpeedButton;
    EndeBtn: TBitBtn;
    btnExtract: TSpeedButton;
    OpenDialog: TOpenDialog;
    Label3: TLabel;
    StrFileEdit: THistoryCombo;
    FileEdit: THistoryCombo;
    FileBtn: TSpeedButton;
    StatusBar: TStaticText;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure EndeBtnClick(Sender: TObject);
    procedure InfoBtnClick(Sender: TObject);
    procedure FileBtnClick(Sender: TObject);
    procedure btnExtractClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    ArbPfad,
    PrgPfad,PrgName,
    IniName          : string;
  public
    { Public-Deklarationen }
  end;

var
  HauptForm: THauptForm;

implementation

{$R *.DFM}

uses ShlObj, StrUtils, IniFiles;

const
  IniExt = 'ini';

  (* INI-Sektionen *)
  CfGSekt = 'Config';
  SourceSekt = 'Source';
  DestSekt = 'Dest';
  FileSekt = 'Files';

  (* INI-Variablen *)
  iniSubDir = 'Subdirectories';

{ ------------------------------------------------------------------- }
(* INI-File lesen *)
procedure THauptForm.FormCreate(Sender: TObject);
var
  IniFile  : TIniFile;
begin
  PrgPfad:=ExtractFilePath(Application.ExeName);
  PrgName:=ExtractFileName(DelExt(Application.ExeName));
  ArbPfad:=GetDesktopFolder(CSIDL_PERSONAL);
  IniName:=Erweiter(ArbPfad,PrgName,IniExt);
  IniFile:=TIniFile.Create(IniName);
  StrFileEdit.LoadFromIni (IniName,DestSekt);
  StrFileEdit.ItemIndex:=0;
  FileEdit.LoadFromIni (IniName,SourceSekt);
  FileEdit.ItemIndex:=0;
  end;

procedure THauptForm.FormDestroy(Sender: TObject);
begin
  end;

{ ------------------------------------------------------------------- }
(* Programmende *)
procedure THauptForm.EndeBtnClick(Sender: TObject);
begin
  Close;
  end;

{ ------------------------------------------------------------------- }
procedure THauptForm.InfoBtnClick(Sender: TObject);
begin
  InfoDialog('','Extract strings from Delphi RC file'+Vers+#13+CopRgt);
  end;

{ ------------------------------------------------------------------- }
procedure THauptForm.FileBtnClick(Sender: TObject);
var
  i : integer;
  s : string;
begin
  with OpenDialog do begin
    if length(StrFileEdit.Text)>0 then InitialDir:=ExtractFilePath(StrFileEdit.Text)
    else InitialDir:=ArbPfad;
    Filename:='';
    Filter:='Resource files|*.'+DrcExt+'|all|*.*';
    Title:='Select resource file';
    if Execute then with FileEdit do begin
      Text:=Filename; AddItem(Filename);
      with StrFileEdit do begin
        Text:=NewExt(Filename,StrExt); AddItem(Text);
        end;
      end;
    end;
  end;

procedure THauptForm.btnExtractClick(Sender: TObject);
var
  s,t,oname     : string;
  fText,oText   : TextFile;
  lCnt,sCnt,
  i,n,k1,k2     : integer;
  body,ok       : boolean;
begin
  t:=FileEdit.Text;
  if length(t)>0 then begin
    Screen.Cursor:=crHourglass;
    with StatusBar do begin
      Font.Color:=clBlack;
      Caption:='';
      end;
    sCnt:=0;
    oName:=StrFileEdit.Text;
    AssignFile(fText,FileEdit.Text); reset(fText);
    AssignFile(oText,oName); rewrite(oText);
    lCnt:=0; body:=false;
    s:=FileEdit.Text;
    writeln(oText,'//',s);
    writeln(oText,'//',StringOfChar('-',length(s)));
    writeln(oText);
    while not Eof(fText) do begin
      readln(fText,s); inc(lCnt);
      ok:=copy(trim(s),1,2)<>'/*';
      if ok and (AnsiCompareText('STRINGTABLE',s)=0) then begin
        ok:=false; body:=true;
        end;
      if ok then ok:=(AnsiCompareText('BEGIN',s)<>0) and (AnsiCompareText('END',s)<>0);
      if ok and body then begin
        k1:=Pos('"',s); k2:=k1;
        repeat
          k2:=PosEx('"',s,k2+1);
          until (k2=0) or (s[k2-1]<>'\');
        if k2>k1+1 then t:=copy(s,k1+1,k2-k1-1) else t:='';
        if length(t)>0 then begin
          writeln(oText,'/:',ZStrint(lCnt,5),' ',copy(s,1,k1-1));
          writeln(oText,'//',t);
          writeln(oText,t);
          writeln(oText);
          inc(sCnt);
          end;
        end;
      end;
    CloseFile(fText); CloseFile(oText);
    with StatusBar do begin
      Font.Color:=clBlue;
      Caption:=' '+IntToStr(sCnt)+' Strings extracted';
      end;
    Screen.Cursor:=crDefault;
    end
  else StatusBar.Caption:=' Nothing to do!';
  end;

end.
